using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Win32;
using System.Xml;
using Aist.Utils;
using System.Text;
using System.Text.RegularExpressions;
using System.Runtime.InteropServices;
using System.Threading;
using System.Reflection;
using System.IO;
using System.Diagnostics;

namespace RegExRep
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox tbFind;
		private System.Windows.Forms.TextBox tbReplaceTo;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.OpenFileDialog OpenFile;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBarButton tbbNew;
		private System.Windows.Forms.ToolBarButton tbbOpen;
		private System.Windows.Forms.ToolBarButton tbbSave;
		private System.Windows.Forms.MenuItem miNew;
		private System.Windows.Forms.MenuItem miOpen;
		private System.Windows.Forms.MenuItem miSave;
		private System.Windows.Forms.MenuItem miSaveAs;
		private System.Windows.Forms.MenuItem miRecent;
		private System.Windows.Forms.Button pbBroseFolder;
		private System.Windows.Forms.TreeView tvFiles;
		private System.Windows.Forms.ListBox lbFileMatch;
		private System.Windows.Forms.Panel pnPreview;
		private System.Windows.Forms.Splitter splHorPrivew;
		private System.Windows.Forms.Splitter splVerPrivew;
		private System.Windows.Forms.Splitter splHorSetings;
		private System.Windows.Forms.TextBox tbPath;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem miBrowseForFolder;
		private System.Windows.Forms.SaveFileDialog SaveFile;
		private System.Windows.Forms.CheckBox cbIgnoreCase;
		private System.Windows.Forms.CheckBox cbMultiline;
		private System.Windows.Forms.CheckBox cbIgnorePatternWhitespace;
		private System.Windows.Forms.TextBox tbExtensions;
		private System.Windows.Forms.TabPage tabPgFindeOnly;
		private System.Windows.Forms.TabPage tabPgFindeAndReplace;
		private System.Windows.Forms.TextBox tbFileBody;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TextBox tbReplaceResult;
		private System.Windows.Forms.Panel pnFindeAndReplace;
		private System.Windows.Forms.TabControl tabPreview;
		private System.ComponentModel.IContainer components;

		private const string csAppName = "Asc Search";
		private const int ciPanelMain = 0;
		private const int ciPanelFileCount = 1;

		private System.Windows.Forms.MenuItem miRun;
		private System.Windows.Forms.MenuItem miRunGo;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem miFileExit;
		private System.Windows.Forms.StatusBarPanel sbpMain;
		private System.Windows.Forms.StatusBarPanel sbpFileCount;
		private System.Windows.Forms.ToolBarButton tbbReplaceInFile;
		private System.Windows.Forms.ToolBarButton tbs1;
		private System.Windows.Forms.ToolBarButton tbs2;
		private System.Windows.Forms.TextBox tbLog;
		private System.Windows.Forms.ToolBarButton tbbClearLog;
		private System.Windows.Forms.ToolBarButton tbbSaveLog;
		private System.Windows.Forms.ToolBar toolBarLog;
		private System.Windows.Forms.SaveFileDialog SaveLog;
		private System.Windows.Forms.CheckBox cbExplicitCapture;
		private System.Windows.Forms.CheckBox cbSingleline;
		private System.Windows.Forms.CheckBox cbCompiled;
		private System.Windows.Forms.TabPage tpSetings;
		private System.Windows.Forms.CheckBox cbReplAll;
		private System.Windows.Forms.TextBox tbReplCount;
		private System.Windows.Forms.TabPage tpPreview;
		private System.Windows.Forms.TabPage tpLog;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.ToolBarButton pbs3;
		private System.Windows.Forms.ToolBarButton tbbEsc;
		private System.Windows.Forms.Label lblPath;
		private System.Windows.Forms.GroupBox gbRegExpOptions;
		private System.Windows.Forms.Label lblFilesPatern;
		private System.Windows.Forms.ImageList imageList2;
		private string m_sCurrentTvPath = "";
		
		class AscMatch
		{
			Match m_m;
			internal Match Match
			{
				get { return m_m; }
				//set { m_m = value; }
			}
			internal AscMatch(Match m)
			{
				m_m = m;
			}
			public override string ToString()
			{
				return "(Index=" + m_m.Index + ", Len=" + m_m.Length + ")	" + m_m.ToString();
			}
		}
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.tbReplaceTo = new System.Windows.Forms.TextBox();
			this.tbFind = new System.Windows.Forms.TextBox();
			this.tbReplCount = new System.Windows.Forms.TextBox();
			this.cbReplAll = new System.Windows.Forms.CheckBox();
			this.cbIgnoreCase = new System.Windows.Forms.CheckBox();
			this.cbMultiline = new System.Windows.Forms.CheckBox();
			this.cbExplicitCapture = new System.Windows.Forms.CheckBox();
			this.cbIgnorePatternWhitespace = new System.Windows.Forms.CheckBox();
			this.cbCompiled = new System.Windows.Forms.CheckBox();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.sbpMain = new System.Windows.Forms.StatusBarPanel();
			this.sbpFileCount = new System.Windows.Forms.StatusBarPanel();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbbNew = new System.Windows.Forms.ToolBarButton();
			this.tbs2 = new System.Windows.Forms.ToolBarButton();
			this.tbbOpen = new System.Windows.Forms.ToolBarButton();
			this.tbbSave = new System.Windows.Forms.ToolBarButton();
			this.tbs1 = new System.Windows.Forms.ToolBarButton();
			this.tbbReplaceInFile = new System.Windows.Forms.ToolBarButton();
			this.pbs3 = new System.Windows.Forms.ToolBarButton();
			this.tbbEsc = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tpSetings = new System.Windows.Forms.TabPage();
			this.tbExtensions = new System.Windows.Forms.TextBox();
			this.tbPath = new System.Windows.Forms.TextBox();
			this.pbBroseFolder = new System.Windows.Forms.Button();
			this.lblFilesPatern = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splHorSetings = new System.Windows.Forms.Splitter();
			this.lblPath = new System.Windows.Forms.Label();
			this.gbRegExpOptions = new System.Windows.Forms.GroupBox();
			this.cbSingleline = new System.Windows.Forms.CheckBox();
			this.tpPreview = new System.Windows.Forms.TabPage();
			this.pnPreview = new System.Windows.Forms.Panel();
			this.tabPreview = new System.Windows.Forms.TabControl();
			this.tabPgFindeOnly = new System.Windows.Forms.TabPage();
			this.tbFileBody = new System.Windows.Forms.TextBox();
			this.tabPgFindeAndReplace = new System.Windows.Forms.TabPage();
			this.pnFindeAndReplace = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.tbReplaceResult = new System.Windows.Forms.TextBox();
			this.splHorPrivew = new System.Windows.Forms.Splitter();
			this.lbFileMatch = new System.Windows.Forms.ListBox();
			this.splVerPrivew = new System.Windows.Forms.Splitter();
			this.tvFiles = new System.Windows.Forms.TreeView();
			this.tpLog = new System.Windows.Forms.TabPage();
			this.tbLog = new System.Windows.Forms.TextBox();
			this.toolBarLog = new System.Windows.Forms.ToolBar();
			this.tbbClearLog = new System.Windows.Forms.ToolBarButton();
			this.tbbSaveLog = new System.Windows.Forms.ToolBarButton();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.miNew = new System.Windows.Forms.MenuItem();
			this.miOpen = new System.Windows.Forms.MenuItem();
			this.miSave = new System.Windows.Forms.MenuItem();
			this.miSaveAs = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.miBrowseForFolder = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.miRecent = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.miFileExit = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.miRun = new System.Windows.Forms.MenuItem();
			this.miRunGo = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.OpenFile = new System.Windows.Forms.OpenFileDialog();
			this.SaveFile = new System.Windows.Forms.SaveFileDialog();
			this.SaveLog = new System.Windows.Forms.SaveFileDialog();
			this.imageList2 = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.sbpMain)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpFileCount)).BeginInit();
			this.tabControl1.SuspendLayout();
			this.tpSetings.SuspendLayout();
			this.panel1.SuspendLayout();
			this.gbRegExpOptions.SuspendLayout();
			this.tpPreview.SuspendLayout();
			this.pnPreview.SuspendLayout();
			this.tabPreview.SuspendLayout();
			this.tabPgFindeOnly.SuspendLayout();
			this.tabPgFindeAndReplace.SuspendLayout();
			this.tpLog.SuspendLayout();
			this.SuspendLayout();
			// 
			// tbReplaceTo
			// 
			this.tbReplaceTo.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tbReplaceTo.Location = new System.Drawing.Point(0, 62);
			this.tbReplaceTo.Multiline = true;
			this.tbReplaceTo.Name = "tbReplaceTo";
			this.tbReplaceTo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbReplaceTo.Size = new System.Drawing.Size(392, 181);
			this.tbReplaceTo.TabIndex = 5;
			this.tbReplaceTo.Text = "";
			this.toolTip1.SetToolTip(this.tbReplaceTo, "Replace by");
			this.tbReplaceTo.WordWrap = false;
			this.tbReplaceTo.TextChanged += new System.EventHandler(this.AllTexBox_TextChanged);
			// 
			// tbFind
			// 
			this.tbFind.Dock = System.Windows.Forms.DockStyle.Top;
			this.tbFind.Multiline = true;
			this.tbFind.Name = "tbFind";
			this.tbFind.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbFind.Size = new System.Drawing.Size(392, 56);
			this.tbFind.TabIndex = 3;
			this.tbFind.Text = "";
			this.toolTip1.SetToolTip(this.tbFind, "Text to search");
			this.tbFind.WordWrap = false;
			this.tbFind.TextChanged += new System.EventHandler(this.AllTexBox_TextChanged);
			// 
			// tbReplCount
			// 
			this.tbReplCount.Location = new System.Drawing.Point(88, 22);
			this.tbReplCount.Name = "tbReplCount";
			this.tbReplCount.Size = new System.Drawing.Size(56, 20);
			this.tbReplCount.TabIndex = 6;
			this.tbReplCount.Text = "1";
			this.tbReplCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.toolTip1.SetToolTip(this.tbReplCount, "Replace count");
			this.tbReplCount.Visible = false;
			this.tbReplCount.Validating += new System.ComponentModel.CancelEventHandler(this.tbReplCount_Validating);
			this.tbReplCount.TextChanged += new System.EventHandler(this.AllTexBox_TextChanged);
			// 
			// cbReplAll
			// 
			this.cbReplAll.Checked = true;
			this.cbReplAll.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbReplAll.Location = new System.Drawing.Point(8, 24);
			this.cbReplAll.Name = "cbReplAll";
			this.cbReplAll.Size = new System.Drawing.Size(104, 16);
			this.cbReplAll.TabIndex = 5;
			this.cbReplAll.Text = "&Replace All";
			this.toolTip1.SetToolTip(this.cbReplAll, "     ");
			this.cbReplAll.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			this.cbReplAll.CheckedChanged += new System.EventHandler(this.cbReplAll_CheckedChanged);
			// 
			// cbIgnoreCase
			// 
			this.cbIgnoreCase.Checked = true;
			this.cbIgnoreCase.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbIgnoreCase.Location = new System.Drawing.Point(8, 48);
			this.cbIgnoreCase.Name = "cbIgnoreCase";
			this.cbIgnoreCase.Size = new System.Drawing.Size(88, 16);
			this.cbIgnoreCase.TabIndex = 7;
			this.cbIgnoreCase.Text = "&Ignore Case";
			this.toolTip1.SetToolTip(this.cbIgnoreCase, "  ");
			this.cbIgnoreCase.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			this.cbIgnoreCase.CheckedChanged += new System.EventHandler(this.cbIgnoreCase_CheckedChanged);
			// 
			// cbMultiline
			// 
			this.cbMultiline.Checked = true;
			this.cbMultiline.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbMultiline.Location = new System.Drawing.Point(8, 72);
			this.cbMultiline.Name = "cbMultiline";
			this.cbMultiline.Size = new System.Drawing.Size(80, 16);
			this.cbMultiline.TabIndex = 8;
			this.cbMultiline.Text = "&Multiline";
			this.toolTip1.SetToolTip(this.cbMultiline, "    ");
			this.cbMultiline.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			// 
			// cbExplicitCapture
			// 
			this.cbExplicitCapture.Location = new System.Drawing.Point(8, 96);
			this.cbExplicitCapture.Name = "cbExplicitCapture";
			this.cbExplicitCapture.Size = new System.Drawing.Size(104, 16);
			this.cbExplicitCapture.TabIndex = 9;
			this.cbExplicitCapture.Text = "&Explicit Capture";
			this.toolTip1.SetToolTip(this.cbExplicitCapture, "    \"()\"     ($x) ");
			this.cbExplicitCapture.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			// 
			// cbIgnorePatternWhitespace
			// 
			this.cbIgnorePatternWhitespace.Location = new System.Drawing.Point(8, 144);
			this.cbIgnorePatternWhitespace.Name = "cbIgnorePatternWhitespace";
			this.cbIgnorePatternWhitespace.Size = new System.Drawing.Size(128, 16);
			this.cbIgnorePatternWhitespace.TabIndex = 11;
			this.cbIgnorePatternWhitespace.Text = "&Ignore Whitespace";
			this.toolTip1.SetToolTip(this.cbIgnorePatternWhitespace, "  ");
			this.cbIgnorePatternWhitespace.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			// 
			// cbCompiled
			// 
			this.cbCompiled.Location = new System.Drawing.Point(8, 168);
			this.cbCompiled.Name = "cbCompiled";
			this.cbCompiled.Size = new System.Drawing.Size(128, 16);
			this.cbCompiled.TabIndex = 12;
			this.cbCompiled.Text = "&Compiled";
			this.toolTip1.SetToolTip(this.cbCompiled, "   ");
			this.cbCompiled.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 327);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.sbpMain,
																						  this.sbpFileCount});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(576, 18);
			this.statusBar1.TabIndex = 1;
			this.statusBar1.Text = "statusBar1";
			// 
			// sbpMain
			// 
			this.sbpMain.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbpMain.Text = "-";
			this.sbpMain.ToolTipText = "Current file/path";
			this.sbpMain.Width = 510;
			// 
			// sbpFileCount
			// 
			this.sbpFileCount.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.sbpFileCount.ToolTipText = "File count";
			this.sbpFileCount.Width = 50;
			// 
			// toolBar1
			// 
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbbNew,
																						this.tbs2,
																						this.tbbOpen,
																						this.tbbSave,
																						this.tbs1,
																						this.tbbReplaceInFile,
																						this.pbs3,
																						this.tbbEsc});
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(576, 24);
			this.toolBar1.TabIndex = 2;
			this.toolBar1.ButtonDropDown += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonDropDown);
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbbNew
			// 
			this.tbbNew.ImageIndex = 0;
			this.tbbNew.Tag = "New";
			this.tbbNew.ToolTipText = "   ";
			// 
			// tbs2
			// 
			this.tbs2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbbOpen
			// 
			this.tbbOpen.ImageIndex = 1;
			this.tbbOpen.Style = System.Windows.Forms.ToolBarButtonStyle.DropDownButton;
			this.tbbOpen.Tag = "Open";
			this.tbbOpen.ToolTipText = "   ";
			// 
			// tbbSave
			// 
			this.tbbSave.ImageIndex = 6;
			this.tbbSave.Tag = "Save";
			this.tbbSave.ToolTipText = "     ";
			// 
			// tbs1
			// 
			this.tbs1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbbReplaceInFile
			// 
			this.tbbReplaceInFile.ImageIndex = 5;
			this.tbbReplaceInFile.Tag = "ReplaceInFile";
			this.tbbReplaceInFile.ToolTipText = "   ";
			// 
			// pbs3
			// 
			this.pbs3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbbEsc
			// 
			this.tbbEsc.ImageIndex = 9;
			this.tbbEsc.Tag = "Esc";
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 15);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Silver;
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tpSetings,
																					  this.tpPreview,
																					  this.tpLog});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 24);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(576, 303);
			this.tabControl1.TabIndex = 2;
			this.tabControl1.SelectedIndexChanged += new System.EventHandler(this.tabControl1_SelectedIndexChanged);
			// 
			// tpSetings
			// 
			this.tpSetings.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.tbExtensions,
																					this.tbPath,
																					this.pbBroseFolder,
																					this.lblFilesPatern,
																					this.panel1,
																					this.lblPath,
																					this.gbRegExpOptions});
			this.tpSetings.Location = new System.Drawing.Point(4, 22);
			this.tpSetings.Name = "tpSetings";
			this.tpSetings.Size = new System.Drawing.Size(568, 277);
			this.tpSetings.TabIndex = 0;
			this.tpSetings.Text = "Settings";
			// 
			// tbExtensions
			// 
			this.tbExtensions.AccessibleDescription = "tbExtensions";
			this.tbExtensions.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.tbExtensions.Location = new System.Drawing.Point(472, 16);
			this.tbExtensions.Name = "tbExtensions";
			this.tbExtensions.Size = new System.Drawing.Size(88, 20);
			this.tbExtensions.TabIndex = 13;
			this.tbExtensions.Text = "*.*";
			this.tbExtensions.TextChanged += new System.EventHandler(this.AllTexBox_TextChanged);
			// 
			// tbPath
			// 
			this.tbPath.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tbPath.Location = new System.Drawing.Point(40, 255);
			this.tbPath.Name = "tbPath";
			this.tbPath.Size = new System.Drawing.Size(499, 20);
			this.tbPath.TabIndex = 9;
			this.tbPath.Text = "textBox1";
			this.tbPath.TextChanged += new System.EventHandler(this.AllTexBox_TextChanged);
			// 
			// pbBroseFolder
			// 
			this.pbBroseFolder.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.pbBroseFolder.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.pbBroseFolder.Location = new System.Drawing.Point(543, 253);
			this.pbBroseFolder.Name = "pbBroseFolder";
			this.pbBroseFolder.Size = new System.Drawing.Size(22, 22);
			this.pbBroseFolder.TabIndex = 8;
			this.pbBroseFolder.Text = "...";
			this.pbBroseFolder.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			this.pbBroseFolder.Click += new System.EventHandler(this.pbBroseFolder_Click);
			// 
			// lblFilesPatern
			// 
			this.lblFilesPatern.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.lblFilesPatern.Location = new System.Drawing.Point(408, 16);
			this.lblFilesPatern.Name = "lblFilesPatern";
			this.lblFilesPatern.Size = new System.Drawing.Size(72, 16);
			this.lblFilesPatern.TabIndex = 7;
			this.lblFilesPatern.Text = "File\'s patern";
			// 
			// panel1
			// 
			this.panel1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.tbReplaceTo,
																				 this.splHorSetings,
																				 this.tbFind});
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(392, 243);
			this.panel1.TabIndex = 3;
			// 
			// splHorSetings
			// 
			this.splHorSetings.Dock = System.Windows.Forms.DockStyle.Top;
			this.splHorSetings.Location = new System.Drawing.Point(0, 56);
			this.splHorSetings.Name = "splHorSetings";
			this.splHorSetings.Size = new System.Drawing.Size(392, 6);
			this.splHorSetings.TabIndex = 4;
			this.splHorSetings.TabStop = false;
			// 
			// lblPath
			// 
			this.lblPath.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.lblPath.Location = new System.Drawing.Point(8, 259);
			this.lblPath.Name = "lblPath";
			this.lblPath.Size = new System.Drawing.Size(32, 16);
			this.lblPath.TabIndex = 5;
			this.lblPath.Text = "&Path:";
			// 
			// gbRegExpOptions
			// 
			this.gbRegExpOptions.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gbRegExpOptions.Controls.AddRange(new System.Windows.Forms.Control[] {
																						  this.tbReplCount,
																						  this.cbReplAll,
																						  this.cbIgnoreCase,
																						  this.cbMultiline,
																						  this.cbExplicitCapture,
																						  this.cbSingleline,
																						  this.cbIgnorePatternWhitespace,
																						  this.cbCompiled});
			this.gbRegExpOptions.Location = new System.Drawing.Point(408, 40);
			this.gbRegExpOptions.Name = "gbRegExpOptions";
			this.gbRegExpOptions.Size = new System.Drawing.Size(152, 208);
			this.gbRegExpOptions.TabIndex = 14;
			this.gbRegExpOptions.TabStop = false;
			this.gbRegExpOptions.Text = "RegExp options";
			// 
			// cbSingleline
			// 
			this.cbSingleline.Checked = true;
			this.cbSingleline.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbSingleline.Location = new System.Drawing.Point(8, 120);
			this.cbSingleline.Name = "cbSingleline";
			this.cbSingleline.Size = new System.Drawing.Size(128, 16);
			this.cbSingleline.TabIndex = 10;
			this.cbSingleline.Text = "&Single line";
			this.cbSingleline.CheckStateChanged += new System.EventHandler(this.AllFlags_CheckStateChanged);
			// 
			// tpPreview
			// 
			this.tpPreview.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.pnPreview,
																					this.splVerPrivew,
																					this.tvFiles});
			this.tpPreview.Location = new System.Drawing.Point(4, 22);
			this.tpPreview.Name = "tpPreview";
			this.tpPreview.Size = new System.Drawing.Size(568, 277);
			this.tpPreview.TabIndex = 2;
			this.tpPreview.Text = "Preview";
			// 
			// pnPreview
			// 
			this.pnPreview.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.tabPreview,
																					this.splHorPrivew,
																					this.lbFileMatch});
			this.pnPreview.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnPreview.Location = new System.Drawing.Point(190, 0);
			this.pnPreview.Name = "pnPreview";
			this.pnPreview.Size = new System.Drawing.Size(378, 277);
			this.pnPreview.TabIndex = 2;
			// 
			// tabPreview
			// 
			this.tabPreview.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.tabPgFindeOnly,
																					 this.tabPgFindeAndReplace});
			this.tabPreview.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabPreview.Location = new System.Drawing.Point(0, 88);
			this.tabPreview.Name = "tabPreview";
			this.tabPreview.SelectedIndex = 0;
			this.tabPreview.Size = new System.Drawing.Size(378, 189);
			this.tabPreview.TabIndex = 4;
			this.tabPreview.SelectedIndexChanged += new System.EventHandler(this.tabPreview_SelectedIndexChanged);
			// 
			// tabPgFindeOnly
			// 
			this.tabPgFindeOnly.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.tbFileBody});
			this.tabPgFindeOnly.Location = new System.Drawing.Point(4, 22);
			this.tabPgFindeOnly.Name = "tabPgFindeOnly";
			this.tabPgFindeOnly.Size = new System.Drawing.Size(370, 163);
			this.tabPgFindeOnly.TabIndex = 0;
			this.tabPgFindeOnly.Text = "Find Only";
			// 
			// tbFileBody
			// 
			this.tbFileBody.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tbFileBody.HideSelection = false;
			this.tbFileBody.Multiline = true;
			this.tbFileBody.Name = "tbFileBody";
			this.tbFileBody.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbFileBody.Size = new System.Drawing.Size(370, 163);
			this.tbFileBody.TabIndex = 7;
			this.tbFileBody.Text = "";
			this.tbFileBody.WordWrap = false;
			// 
			// tabPgFindeAndReplace
			// 
			this.tabPgFindeAndReplace.Controls.AddRange(new System.Windows.Forms.Control[] {
																							   this.pnFindeAndReplace,
																							   this.splitter1,
																							   this.tbReplaceResult});
			this.tabPgFindeAndReplace.Location = new System.Drawing.Point(4, 22);
			this.tabPgFindeAndReplace.Name = "tabPgFindeAndReplace";
			this.tabPgFindeAndReplace.Size = new System.Drawing.Size(370, 163);
			this.tabPgFindeAndReplace.TabIndex = 1;
			this.tabPgFindeAndReplace.Text = "Find & Replace";
			// 
			// pnFindeAndReplace
			// 
			this.pnFindeAndReplace.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnFindeAndReplace.Name = "pnFindeAndReplace";
			this.pnFindeAndReplace.Size = new System.Drawing.Size(370, 69);
			this.pnFindeAndReplace.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 69);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(370, 6);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// tbReplaceResult
			// 
			this.tbReplaceResult.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.tbReplaceResult.Location = new System.Drawing.Point(0, 75);
			this.tbReplaceResult.Multiline = true;
			this.tbReplaceResult.Name = "tbReplaceResult";
			this.tbReplaceResult.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbReplaceResult.Size = new System.Drawing.Size(370, 88);
			this.tbReplaceResult.TabIndex = 6;
			this.tbReplaceResult.Text = "";
			this.tbReplaceResult.WordWrap = false;
			// 
			// splHorPrivew
			// 
			this.splHorPrivew.Dock = System.Windows.Forms.DockStyle.Top;
			this.splHorPrivew.Location = new System.Drawing.Point(0, 82);
			this.splHorPrivew.MinExtra = 40;
			this.splHorPrivew.Name = "splHorPrivew";
			this.splHorPrivew.Size = new System.Drawing.Size(378, 6);
			this.splHorPrivew.TabIndex = 3;
			this.splHorPrivew.TabStop = false;
			// 
			// lbFileMatch
			// 
			this.lbFileMatch.Dock = System.Windows.Forms.DockStyle.Top;
			this.lbFileMatch.Name = "lbFileMatch";
			this.lbFileMatch.Size = new System.Drawing.Size(378, 82);
			this.lbFileMatch.TabIndex = 2;
			this.lbFileMatch.SelectedIndexChanged += new System.EventHandler(this.lbFileMatch_SelectedIndexChanged);
			// 
			// splVerPrivew
			// 
			this.splVerPrivew.Location = new System.Drawing.Point(184, 0);
			this.splVerPrivew.Name = "splVerPrivew";
			this.splVerPrivew.Size = new System.Drawing.Size(6, 277);
			this.splVerPrivew.TabIndex = 1;
			this.splVerPrivew.TabStop = false;
			// 
			// tvFiles
			// 
			this.tvFiles.Dock = System.Windows.Forms.DockStyle.Left;
			this.tvFiles.HideSelection = false;
			this.tvFiles.ImageList = this.imageList2;
			this.tvFiles.Name = "tvFiles";
			this.tvFiles.Size = new System.Drawing.Size(184, 277);
			this.tvFiles.TabIndex = 0;
			this.tvFiles.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvFiles_AfterSelect);
			// 
			// tpLog
			// 
			this.tpLog.Controls.AddRange(new System.Windows.Forms.Control[] {
																				this.tbLog,
																				this.toolBarLog});
			this.tpLog.Location = new System.Drawing.Point(4, 22);
			this.tpLog.Name = "tpLog";
			this.tpLog.Size = new System.Drawing.Size(568, 277);
			this.tpLog.TabIndex = 1;
			this.tpLog.Text = "Log";
			// 
			// tbLog
			// 
			this.tbLog.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tbLog.Location = new System.Drawing.Point(0, 39);
			this.tbLog.Multiline = true;
			this.tbLog.Name = "tbLog";
			this.tbLog.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbLog.Size = new System.Drawing.Size(568, 238);
			this.tbLog.TabIndex = 0;
			this.tbLog.Text = "";
			// 
			// toolBarLog
			// 
			this.toolBarLog.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBarLog.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						  this.tbbClearLog,
																						  this.tbbSaveLog});
			this.toolBarLog.DropDownArrows = true;
			this.toolBarLog.ImageList = this.imageList1;
			this.toolBarLog.Name = "toolBarLog";
			this.toolBarLog.ShowToolTips = true;
			this.toolBarLog.Size = new System.Drawing.Size(568, 39);
			this.toolBarLog.TabIndex = 1;
			this.toolBarLog.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBarLog_ButtonClick);
			// 
			// tbbClearLog
			// 
			this.tbbClearLog.ImageIndex = 8;
			this.tbbClearLog.Tag = "ClearLog";
			// 
			// tbbSaveLog
			// 
			this.tbbSaveLog.ImageIndex = 6;
			this.tbbSaveLog.Tag = "SaveLog";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem7,
																					  this.miRun,
																					  this.menuItem4});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.miNew,
																					  this.miOpen,
																					  this.miSave,
																					  this.miSaveAs,
																					  this.menuItem2,
																					  this.miBrowseForFolder,
																					  this.menuItem3,
																					  this.miRecent,
																					  this.menuItem6,
																					  this.miFileExit});
			this.menuItem1.Text = "&File";
			// 
			// miNew
			// 
			this.miNew.Index = 0;
			this.miNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.miNew.Text = "&New";
			this.miNew.Click += new System.EventHandler(this.miNew_Click);
			// 
			// miOpen
			// 
			this.miOpen.Index = 1;
			this.miOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.miOpen.Text = "&Open...";
			this.miOpen.Click += new System.EventHandler(this.miOpen_Click);
			// 
			// miSave
			// 
			this.miSave.Index = 2;
			this.miSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.miSave.Text = "&Save";
			this.miSave.Click += new System.EventHandler(this.miSave_Click);
			// 
			// miSaveAs
			// 
			this.miSaveAs.Index = 3;
			this.miSaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftS;
			this.miSaveAs.Text = "Save &As...";
			this.miSaveAs.Click += new System.EventHandler(this.miSaveAs_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 4;
			this.menuItem2.Text = "-";
			// 
			// miBrowseForFolder
			// 
			this.miBrowseForFolder.Index = 5;
			this.miBrowseForFolder.Text = "&Browse for folder";
			this.miBrowseForFolder.Click += new System.EventHandler(this.miBrowseForFolder_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 6;
			this.menuItem3.Text = "-";
			// 
			// miRecent
			// 
			this.miRecent.Index = 7;
			this.miRecent.Text = "&Recent";
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 8;
			this.menuItem6.Text = "-";
			// 
			// miFileExit
			// 
			this.miFileExit.Index = 9;
			this.miFileExit.Shortcut = System.Windows.Forms.Shortcut.AltF4;
			this.miFileExit.Text = "E&xit";
			this.miFileExit.Click += new System.EventHandler(this.miFileExit_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 1;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8});
			this.menuItem7.Text = "&Edit";
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 0;
			this.menuItem8.Text = "&Escapes selected text";
			this.menuItem8.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// miRun
			// 
			this.miRun.Index = 2;
			this.miRun.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				  this.miRunGo});
			this.miRun.Text = "&Run";
			// 
			// miRunGo
			// 
			this.miRunGo.Index = 0;
			this.miRunGo.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.miRunGo.Text = "&Go";
			this.miRunGo.Click += new System.EventHandler(this.miRunGo_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 3;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem5});
			this.menuItem4.Text = "&Help";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 0;
			this.menuItem5.Text = "&About";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// OpenFile
			// 
			this.OpenFile.DefaultExt = "shr";
			this.OpenFile.Filter = "Asc Search|*.shr";
			this.OpenFile.Title = "   ";
			// 
			// SaveFile
			// 
			this.SaveFile.DefaultExt = "shr";
			this.SaveFile.FileName = "config1";
			this.SaveFile.Filter = "Asc Search|*.shr";
			this.SaveFile.Title = "         ";
			// 
			// SaveLog
			// 
			this.SaveLog.DefaultExt = "txt";
			this.SaveLog.FileName = "log";
			this.SaveLog.Filter = "Asc Search|*.txt";
			this.SaveLog.Title = "         Log";
			// 
			// imageList2
			// 
			this.imageList2.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList2.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
			this.imageList2.TransparentColor = System.Drawing.Color.Maroon;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 345);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.toolBar1,
																		  this.statusBar1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			((System.ComponentModel.ISupportInitialize)(this.sbpMain)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpFileCount)).EndInit();
			this.tabControl1.ResumeLayout(false);
			this.tpSetings.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.gbRegExpOptions.ResumeLayout(false);
			this.tpPreview.ResumeLayout(false);
			this.pnPreview.ResumeLayout(false);
			this.tabPreview.ResumeLayout(false);
			this.tabPgFindeOnly.ResumeLayout(false);
			this.tabPgFindeAndReplace.ResumeLayout(false);
			this.tpLog.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] Args) 
		{
			try
			{
				bool bRun = false;
				ArrayList arysConfigs = null;
				string sLogFileName = null;
				string sPath = null;

				foreach(string arg in Args)
				{
					string sKey = "";
					if(arg.Length >= 2 && (arg[0] == '/' || arg[0] == '-'))
						sKey = arg[1].ToString();
					else if(arg.Length < 2 || (arg[0] != '/' && arg[0] != '-'))
						throw new Exception("Invalid argument \"" + arg + "\". For more information run this program with -h key.");
					sKey = sKey.ToUpper();
					string sFile = arg.Length > 2 ? arg.Substring(2, arg.Length - 2) : "";
					switch(sKey)
					{
						case "?": // Help
						case "H":
							//     .
							//         .
							//   VS7      (  )
							//         
							//  "Build Action"  "Embedded Resource".
							// StreamReader   Stream  
							//  .
							using(StreamReader sr = new StreamReader(
									  //     GetManifestResourceStream
									  //    Assembly    .
									  //        "RegExRep"
									  //   .
									  Assembly.GetExecutingAssembly().GetManifestResourceStream("RegExRep.Promt.txt"), 
									  //       
									  //  .    Encoding.Default.
									  //       
									  // .      
									  // 1251        
									  //   .    
									  //   .
									  System.Text.Encoding.GetEncoding(1251)))
							{
								//     (sr.ReadToEnd())     .
								MessageBox.Show(sr.ReadToEnd(), csAppName, MessageBoxButtons.OK, MessageBoxIcon.Information);
							}
							return;
						case "L":  // Log
							if(sLogFileName != null)
								throw new Exception("You can specify only one Log-file as a parameter!");
							sLogFileName = sFile;
							break;
						case "D": // Dir
							if(sPath != null)
								throw new Exception("You can specify only one directory as a parameter!");
							sPath = sFile;
							break;
						case "R":
							bRun = true;
							break;
						case "S":
							if(arysConfigs == null)
								arysConfigs = new ArrayList();
							arysConfigs.Add(sFile);
							break;
						default:
							throw new Exception("Invalid argument '" + sKey + "'");
					}
				}

				if(bRun && arysConfigs == null)
					throw new Exception("If you start the program -r option (batch processing), you must specify at least one *.shr-file!");

				Form1 frmMain = new Form1();
				if(bRun)
				{
					foreach(string sConfig in arysConfigs)
						frmMain.Run(sConfig, sPath);
					if(sLogFileName != null)
						frmMain.LogSave(sLogFileName);
				}
				else
				{
					frmMain.Init(arysConfigs == null ? "" : (string)arysConfigs[0], null);
					Application.Run(frmMain);
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		/// <summary>    -.</summary>
		public bool m_bCancelBatch = false;

		/// <summary>
		///    .     
		///   .
		/// </summary>
		/// <param name="sShrFileName">  .</param>
		public void Run(string sShrFileName, string sPath)
		{
			if(m_bCancelBatch)
				return;
			Init(sShrFileName, sPath);
			ReplaceInFile();
		}


		//TODO:    (, csAppName)     .Net
		   
		public void Init(string sShrFileName, string sPath)
		{
			Visible = false;

				if(sShrFileName != null && sShrFileName.Length > 0)
					m_sCurrentConfig = sShrFileName;
				else //       ,    .
				{
					try //   ...
					{
						using(RegistryKey rk = Registry.CurrentUser)
						using(RegistryKey rkAscSearch = rk.CreateSubKey(@"Software\OPTIM.RU\AscSearch"))
							m_sCurrentConfig = (string)rkAscSearch.GetValue("m_sCurrentConfig");
					}
					catch {} //   ...
			}
			OpenConfig(m_sCurrentConfig);
			if(sPath != null && sPath.Length > 0)
				tbPath.Text = sPath;
		}


		// vars
		AscSearchEngine m_SearchEngine = new AscSearchEngine();
		string m_sCurrentConfig = "";
		string[] m_asRecent;
		bool m_bIsDirty = false;
		bool m_bLoading = false;


		/// <summary>
		///      Recent-. 
		///     ,    .
		/// </summary>
		void RecentAdd(string sConfigName)
		{
			sConfigName = sConfigName.ToLower(); //  .
			string[] asNew = null;
			//      , ...
			if(m_asRecent == null || m_asRecent.Length == 0)
				asNew = new string[1]; //     .
			else //        .
			{
				// .  Recent- (  ).
				const int ciRecentMax = 30;

				// ,     ...
				int i = Array.IndexOf(m_asRecent, sConfigName);
				//   (sConfigName)    , i 
				//  -1.  i     
				// .         
				//     
				// (ciRecentMax),     .   
				//      . 
				// (    .) 
				asNew = i >= 0 || m_asRecent.Length >= ciRecentMax
					? m_asRecent //   .
					//   ,     .
					: new string[m_asRecent.Length + 1];
				//    ,  ,    
				//   ()  .
				if(i < 0)
					i = asNew.GetUpperBound(0);
				//  ,       .
				Array.Copy(m_asRecent, 0, asNew, 1, i);
				//      .
			}
			//       .
			asNew[0] = sConfigName;
			m_asRecent = asNew;
			RecentUpdate();
		}

		const string m_csRecentKey = @"Software\OPTIM.RU\AscSearch\Recent";
		/// <summary>
		///  Recent-  . 
		/// </summary>
		void RecentPersistInRegSave()
		{
			RegistryKey rk = Registry.CurrentUser;
			rk.OpenSubKey(@"Software\OPTIM.RU", true);
			try
			{ 
				try{ rk.DeleteSubKeyTree(m_csRecentKey); } catch{}
				RegistryKey rkRecentKey = rk.CreateSubKey(m_csRecentKey);
				if(m_asRecent == null)
					rkRecentKey.SetValue("Count", 0);
				else
				{
					rkRecentKey.SetValue("Count", m_asRecent.Length);
					for(int i = 0; i < m_asRecent.Length; i++)
						rkRecentKey.SetValue("Recent" + i, m_asRecent[i]);
				}
			}
			catch(Exception ex)
			{
				MsgBox(ex.Message);
			}
		}
		/// <summary>
		///  Recent-  .
		/// </summary>
		void RecentPersistInRegLoad()
		{
			RegistryKey rk = Registry.CurrentUser;
			rk.OpenSubKey(@"Software\OPTIM.RU", true);
			try
			{ 
				RegistryKey rkRecentKey = rk.OpenSubKey(m_csRecentKey, false); 
				int iCount = (int)rkRecentKey.GetValue("Count");
				if(iCount <= 0)
					return;
				if(iCount > 31)
					throw(new Exception("i > 31"));
				m_asRecent = new string[iCount];
				for(int i = 0; i < iCount; i++)
				{
					m_asRecent[i] = (string)rkRecentKey.GetValue("Recent" + i);
				}
				RecentUpdate();
			}
			catch(Exception ex)
			{
				MsgBox(ex.Message);
			}
		}
void RecentUpdate()
{
	miRecent.MenuItems.Clear();
	foreach(string s in m_asRecent)
		miRecent.MenuItems.Add(s, new System.EventHandler(miRec1_Click));
}
		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch((string)e.Button.Tag)
			{
				case "New":           FileNew();                            break;
				case "Open":          FileOpenConfig();                     break;
				case "Save":          SaveCurrentConfig();                  break;
				case "ReplaceInFile": ReplaceInFileWithPromt();             break;
				case "Esc":           EscepeSelection();                    break;
				default:              MessageBox.Show(" !");  break;
			} 
		}

		void MsgBox(string sMsg)
		{
			MessageBox.Show(this, sMsg, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
		}

		void FileOpenConfig()
		{
			//      .
			if(TrySave())
				//      ...
				if(DialogResult.OK == OpenFile.ShowDialog())
					OpenConfigSafe(OpenFile.FileName);
		}
		void FileNew()
		{
			//      .
			if(!TrySave())
				return;
			m_sCurrentConfig = "";
			tbFind.Text = "";
			tbReplaceTo.Text = "";
			tbPath.Text = "";
			tbExtensions.Text = "*.asp *.htm*";
			cbReplAll.Checked = true;
			cbIgnoreCase.Checked = true;
			cbMultiline.Checked = true;
			cbExplicitCapture.Checked = false;
			cbSingleline.Checked = true;
			cbIgnorePatternWhitespace.Checked = false;
			cbCompiled.Checked = false;
			SetDirty(false);
		}
		private void Form1_Load(object sender, System.EventArgs e)
		{
			try //   ...
			{
				//      .
				using(RegistryKey rk = Registry.CurrentUser)
				using(RegistryKey rkAscSearch = rk.CreateSubKey(@"Software\OPTIM.RU\AscSearch"))
				{
					Top = (int)rkAscSearch.GetValue("Top");
					Left = (int)rkAscSearch.GetValue("Left");
					Height = (int)rkAscSearch.GetValue("Height");
					Width = (int)rkAscSearch.GetValue("Width");
					WindowState = (FormWindowState)rkAscSearch.GetValue("WindowState");
					splHorPrivew.SplitPosition = (int)rkAscSearch.GetValue("splHorPrivew.SplitPosition");
					splVerPrivew.SplitPosition = (int)rkAscSearch.GetValue("splVerPrivew.SplitPosition");
					splHorSetings.SplitPosition = (int)rkAscSearch.GetValue("splHorSetings.SplitPosition");
				}
				//     .
				RecentPersistInRegLoad();
			}
			catch {} //   ...
			OpenConfig(m_sCurrentConfig);
			Visible = true;
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			using(RegistryKey rk = Registry.CurrentUser)
			using(RegistryKey rkAscSearch = rk.CreateSubKey(@"Software\OPTIM.RU\AscSearch"))
			{
				if(FormWindowState.Minimized != WindowState)
					rkAscSearch.SetValue("WindowState", (int)WindowState);
				if(FormWindowState.Normal == WindowState)
				{
					rkAscSearch.SetValue("Top", Top);
					rkAscSearch.SetValue("Left", Left);
					rkAscSearch.SetValue("Height", Height);
					rkAscSearch.SetValue("Width", Width);
				}
				rkAscSearch.SetValue("splHorPrivew.SplitPosition", splHorPrivew.SplitPosition);
				rkAscSearch.SetValue("splVerPrivew.SplitPosition", splVerPrivew.SplitPosition);
				rkAscSearch.SetValue("splHorSetings.SplitPosition", splHorSetings.SplitPosition);
				rkAscSearch.SetValue("m_sCurrentConfig", m_sCurrentConfig);
				RecentPersistInRegSave();
			}
		}

		private void cbGlobal_CheckedChanged(object sender, System.EventArgs e)
		{
			SetDirty(true);
		}

		private void SplitterShamanism()
		{
			if(this.WindowState == FormWindowState.Normal)
			{
				splHorPrivew.SplitPosition = splHorPrivew.SplitPosition;
				splVerPrivew.SplitPosition = splVerPrivew.SplitPosition;
				splHorSetings.SplitPosition = splHorSetings.SplitPosition;
			}	
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			SplitterShamanism();
		}

		void BroseForFolder()
		{
			BrowseFolderDialog bfd = new BrowseFolderDialog();
			bfd.InitialFolderName = tbPath.Text;
			bfd.Description = "Choice folder";
			bfd.Flags = BrowseDialogFlags.ReturnOnlyFSDirs | BrowseDialogFlags.NewDialogStyle | BrowseDialogFlags.UseNewUI;
			if(DialogResult.OK == bfd.ShowDialog(this))
				tbPath.Text = bfd.FolderName;
		}
		
		/// <summary>      
		///  !</summary>
		void SaveToXmlControlText(XmlDocument doc, Control ctrl)
		{
			//    XML-.
			XmlNode root = doc.DocumentElement;
			//        .
			string sName = ctrl.Name.Remove(0, 2);
			//  XML-.
			XmlNode Elem = doc.CreateNode(XmlNodeType.Element, sName, "");
			//  XML-.
			XmlNode ElemTxt = doc.CreateNode(XmlNodeType.Text, "", "");
			//     XML-.
			ElemTxt.Value = ctrl.Text;
			//  XML-  XML-.
			Elem.AppendChild(ElemTxt);
			//  XML-    .
			root.AppendChild(Elem);
		}

		/// <summary>  CheckBox-   
		///  </summary>
		void SaveToXmlCheckBox(XmlDocument doc, CheckBox ctrl)
		{
			XmlNode root = doc.DocumentElement;
			string sName = ctrl.Name.Remove(0, 2);
			XmlNode Elem = doc.CreateNode(XmlNodeType.Element, sName, "");
			XmlNode ElemTxt = doc.CreateNode(XmlNodeType.Text, "", "");
			ElemTxt.Value = ctrl.Checked.ToString();
			Elem.AppendChild(ElemTxt);
			root.AppendChild(Elem);
		}

		/// <summary>
		///        "Save As"
		///       .
		/// </summary>
		void SaveConfigAs()
		{
			//      ( Save)...
			if(DialogResult.OK == SaveFile.ShowDialog(this))
			{
				try
				{
       
					//  ...
					SaveConfig(SaveFile.FileName);
					//  ,    ...
					m_sCurrentConfig = SaveFile.FileName;
					//     Recent-.
					RecentAdd(m_sCurrentConfig);
				}
				catch(Exception e)
				{ //        
					// . MsgBox    -.
					MsgBox("Can not save settings to the configuration file.\r\nError: "
						+ e.Message); 
				}
			}
		}
		
		void SaveCurrentConfig()
		{
			try{ SaveConfig(m_sCurrentConfig); }
			catch{ SaveConfigAs(); }
		}

		/// <summary>
		///     XML-.
		/// sName:  .
		/// </summary>
		/// <param name="sName"> XML-.</param>
		void SaveConfig(string sName)
		{
			XmlDocument doc = new XmlDocument();
			XmlNode root = doc.CreateNode(XmlNodeType.Element, "shr", "");
			//XmlNode cdata = doc.CreateNode(XmlNodeType.CDATA, "", "");
			doc.AppendChild(root);
			
			//        
			//   .  .  - OpenConfig.
			foreach(Control ctrl in GetStatefullCtrls(tpSetings.Controls))
			{
				if(ctrl is CheckBox)
					SaveToXmlCheckBox(doc, ctrl as CheckBox);
				else if(ctrl is TextBox)
					SaveToXmlControlText(doc, ctrl);
				else
					throw new Exception(string.Format(
						"Unknown control type.  Name={0}, Info={1}", 
						ctrl.Name, 
						ctrl.ToString()));
			}

			//     Preview-.
			if(null != tvFiles.SelectedNode)
			{
				XmlNode Elem = doc.CreateNode(XmlNodeType.Element, "m_sCurrentTvPath", "");
				XmlNode ElemTxt = doc.CreateNode(XmlNodeType.Text, "", "");
				ElemTxt.Value = tvFiles.SelectedNode.FullPath;
				Elem.AppendChild(ElemTxt);
				root.AppendChild(Elem);
			}

			doc.Save(sName);
			SetDirty(false);
		}

		void SetDirty(bool bIsDirty)
		{
			if(!m_bLoading)
				m_bIsDirty = bIsDirty;
			Text = csAppName + " - " + 
				((m_sCurrentConfig != null && m_sCurrentConfig.Length > 0)
				? m_sCurrentConfig : "<New search>") 
				   + (m_bIsDirty && !m_bLoading ? " *" : "");
		}

		RegexOptions GetRegExOptions()
		{
			RegexOptions o = RegexOptions.None;
			//if(cbGlobal.Checked) o |= RegexOptions.G
			if(cbIgnoreCase.Checked)              o |= RegexOptions.IgnoreCase;
			if(cbMultiline.Checked)               o |= RegexOptions.Multiline;
			if(cbExplicitCapture.Checked)         o |= RegexOptions.ExplicitCapture;
			if(cbSingleline.Checked)              o |= RegexOptions.Singleline;
			if(cbIgnorePatternWhitespace.Checked) o |= RegexOptions.IgnorePatternWhitespace;
			if(cbCompiled.Checked)                o |= RegexOptions.Compiled;
			return o;
		}

		AscRegExpParser m_Rep = null;

		void PreviewReadDirs()
		{
			try
			{
				m_Rep = new AscRegExpParser(tbFind.Text, tbReplaceTo.Text, GetRegExOptions());
				string sPath = m_sCurrentTvPath;
				int iSelFileMatch = lbFileMatch.SelectedIndex;

				tvFiles.BeginUpdate();
				try
				{
					m_SearchEngine.ScanDir(tbPath.Text, tbExtensions.Text);
					m_SearchEngine.FillTreeView(tvFiles);

					tvFiles.SelectedNode = FindNode(tvFiles.Nodes, sPath);
					if(iSelFileMatch >= 0 && lbFileMatch.Items.Count > iSelFileMatch)
						lbFileMatch.SelectedIndex = iSelFileMatch;
					statusBar1.Panels[ciPanelFileCount].Text = m_SearchEngine.FilesCount.ToString();
				} 
				finally { tvFiles.EndUpdate(); }
			}
			catch(System.Exception ex)
			{
				MessageBox.Show(ex.Message, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			GC.Collect();
		}

		private void tabControl1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			SplitterShamanism();
			if(tpPreview == tabControl1.SelectedTab)
				PreviewReadDirs();
		}

		/// <summary>
		///  XML- .     
		///          
		/// (  ).
		/// </summary>
		/// <param name="sName"> XML-.</param>
		void OpenConfigSafe(string sName)
		{
			try{ OpenConfig(sName); } catch(Exception ex){ MessageBox.Show(ex.Message, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error); }
		}

		/// <summary>
		///  XML- .
		/// </summary>
		/// <param name="sName"> XML-. Null   
		///     .</param>
		void OpenConfig(string sName)
		{
			tabControl1.SelectedIndex = 0;

			if(sName == null || sName.Length == 0)
			{
				SetDirty(false);
				FileNew();
				return;
			}
			m_bLoading = true;
			try
			{
				XmlDocument doc = new XmlDocument();
				doc.Load(sName);
				XmlElement d = doc.DocumentElement;

				//         
				//    .
				foreach(Control ctrl in GetStatefullCtrls(tpSetings.Controls))
				{
					//      (cb  tb)
					//         
					//   .
					string Name = ctrl.Name.Remove(0, 2);
					if(ctrl is CheckBox)
						//     bool   bool.Parse()
						try{ (ctrl as CheckBox).Checked = bool.Parse(d.SelectSingleNode(Name).InnerText); } catch{}
					else if(ctrl is TextBox)
						//     try{ } catch{},      
						//  xml      ,      .
						try{ (ctrl as TextBox).Text = d.SelectSingleNode(Name).InnerText; } catch{}
					else
						throw new Exception(string.Format("Unknown control type.  Name={0}, Info={1}", ctrl.Name, ctrl.ToString()));
				}
				try{ m_sCurrentTvPath = d.SelectSingleNode("m_sCurrentTvPath").InnerText; } catch{}
				m_sCurrentConfig = sName; //    
				RecentAdd(sName); //    
			}
			catch(Exception ex){ throw new Exception("Can not open the configuration file\"" + sName + "\"\n\nError: " + ex.Message); }
			finally{ m_bLoading = false; }
			//      ...
			SetDirty(false); // ...   "".
		}

		private void miOpen_Click(object sender, System.EventArgs e){FileOpenConfig();}
		private void miNew_Click(object sender, System.EventArgs e){ FileNew(); }
		private void miBrowseForFolder_Click(object sender, System.EventArgs e){ BroseForFolder(); }
		private void pbBroseFolder_Click(object sender, System.EventArgs e){ BroseForFolder(); }
		private void miSaveAs_Click(object sender, System.EventArgs e) { SaveConfigAs(); }
		private void miSave_Click(object sender, System.EventArgs e) { SaveCurrentConfig(); }
		private void AllTexBox_TextChanged(object sender, System.EventArgs e) { SetDirty(true); }
		
		/// <summary>       Recent-.</summary>
		private void miRec1_Click(object sender, System.EventArgs e)
		{
			//      .
			if(TrySave())
				OpenConfigSafe((sender as MenuItem).Text);
		}

		/// <summary>
		///     .
		/// </summary>
		/// <param name="sPath1"> .    '/'  '\\',
		///    .</param>
		/// <param name="sPath2">    '/'  '\\'.</param>
		/// <returns></returns>
		private static string MakePath(string sPath1, string sPath2)
		{
			StringBuilder sb = new StringBuilder(sPath1, 1000);
			if(sb.Length > 0)
				if(sb[sb.Length - 1] != '/' || sb[sb.Length - 1] != '\\')
					sb.Append('\\');
			sb.Append(sPath2);
			return sb.ToString();
		}

		/// <summary>
		///         ( Preview).
		/// </summary>
		private void tvFiles_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode tnSel = tvFiles.SelectedNode;
			if(tnSel == null)
				return;
			m_sCurrentTvPath = tnSel.FullPath;

			string sPath = MakePath(tbPath.Text, m_sCurrentTvPath);
			SetStatusTetx(sPath);

			if(tnSel.ImageIndex != AscSearchEngine.ciFileSel)
			{
				lbFileMatch.Items.Clear();
				tbFileBody.Clear();
				return; //     , ...
			}

			GC.Collect();
			tbFileBody.Text = m_Rep.ReadFile(sPath);
			MatchCollection mc = m_Rep.Parse(tbFileBody.Text);
			lbFileMatch.BeginUpdate();
			try
			{
				lbFileMatch.Items.Clear();
				foreach(Match m in mc)
					lbFileMatch.Items.Add(new AscMatch(m));
				if(lbFileMatch.Items.Count > 0)
					lbFileMatch.SelectedIndex = 0;
			}
			finally
			{
				lbFileMatch.EndUpdate();
			}
			GC.Collect();
		}

		const int EM_SCROLLCARET = 0x00B7;
		[DllImport("User32.dll")]
		extern static int SendMessage(IntPtr hWnd, UInt32 msg, Int32 wParam, Int32 lParam);

		/// <summary>
		///          ( Preview).
		/// </summary>
		private void lbFileMatch_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				AscMatch m = (AscMatch)lbFileMatch.SelectedItem;
				//    .
				tbFileBody.Select(m.Match.Index, m.Match.Length);
				//       .
				//      WinForms,
				//        WinAPI.
				SendMessage(tbFileBody.Handle, EM_SCROLLCARET, 0, 0);
				tbReplaceResult.Text = m.Match.Result(tbReplaceTo.Text);
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void tabPreview_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(tabPgFindeAndReplace == tabPreview.SelectedTab)
				tbFileBody.Parent = pnFindeAndReplace;
			else
				tbFileBody.Parent = tabPgFindeOnly;
		}

		/// <summary>
		///     (  ).
		/// </summary>
		/// <param name="tnc">   .</param>
		/// <param name="sPath">      '\\'
		///  '/'.</param>
		/// <returns>      (TreeNode).
		///   null.</returns>
		TreeNode FindNode(TreeNodeCollection tnc, string sPath)
		{
			string[] aryPathNode = sPath.Split(new char[] {'\\', '/'});
			TreeNode tnCurr = null;
			foreach(string sPathNode in aryPathNode)
			{
				foreach(TreeNode tn in tnc)
				{
					if(tn.Text == sPathNode)
					{
						tnCurr = tn;
						break;
					}
				}
				//    , tnCurr  null
				if(null == tnCurr)
					return null;
				tnc = tnCurr.Nodes;
			}
			return tnCurr;
		}

/// <summary>
///        (Yes, No  Cancel).
/// </summary>
/// <returns>   No,  true.
///    Yes,    .
///    true,    .
///    Cancel,  false.</returns>
bool TrySave()
{
	if(m_bIsDirty)
		switch(MessageBox.Show(this, "Save current settings?", csAppName, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question))
		{
			case DialogResult.Cancel: return false;
			case DialogResult.Yes:    SaveCurrentConfig(); return true;
		}
	return true;
}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			//      
			//   .
			e.Cancel = !TrySave();
		}

		/////////////////////////////////////////////////////////
		//       .
		/////////////////////////////////////////////////////////

		//        .
		frmBatchReplace m_frmBatchRep = new frmBatchReplace();

		private void ReplaceInFileWithPromt()
		{
			if(MessageBox.Show(this, "Do you really want to replace?", 
				csAppName, MessageBoxButtons.OKCancel, MessageBoxIcon.Question)
				== DialogResult.OK)
				ReplaceInFile();
		}

		private void ReplaceInFile()
		{
			tabControl1.SelectedTab = tpLog;
			m_frmBatchRep.ShowDialog(this);
		}

		private void miRunGo_Click(object sender, System.EventArgs e)
		{
			ReplaceInFileWithPromt();
		}

		/// <summary>    ( Result).</summary>
		void BatchReplaseLog(string sText)
		{
			tbLog.Text = sText + "\r\n" + tbLog.Text;
		}

		/// <summary>    ( Result)  StatusBar.</summary>
		void BatchReplaseReport(string sText)
		{
			SetStatusTetx(sText);
			BatchReplaseLog(sText);
		}

		/// <summary>   .</summary>
		int m_iCurrFileIndex;

		/// <summary>
		///  .      ,
		///      .
		/// </summary>
		int m_iReplaceCount;

		/// <summary>    () .</summary>
		/// <param name="sFileName"> .</param>
		public void ProcessFile(string sFileName)
		{
			//       .
			m_iCurrFileIndex++;
			string sFilePath = MakePath(tbPath.Text, sFileName);
			SetStatusTetx(sFilePath);
			try { m_Rep.Replace(sFilePath, m_iReplaceCount); }
			catch(UnauthorizedAccessException ex) 
			{ BatchReplaseLog(ex.Message); }

			m_frmBatchRep.UpdateInfo(m_iCurrFileIndex);
		}

		/// <summary>
		///       
		///  .     
		///  (     
		///    ). 
		/// </summary>
		public void BatchReplase()
		{
			try //         Abort
			{
				//tbLog.Clear();
				BatchReplaseReport(string.Format("Job started at {0} (Log is written in reverse mode).\r\n", DateTime.Now));
				BatchReplaseReport("Processing configuration file: " + m_sCurrentConfig);
				m_iReplaceCount = cbReplAll.Checked ? -1 : int.Parse(tbReplCount.Text);
				m_Rep = new AscRegExpParser(tbFind.Text, tbReplaceTo.Text, GetRegExOptions());
				m_iCurrFileIndex = 0;
				//m_bStopBatchReplase = false;
				m_SearchEngine.ScanDir(tbPath.Text, tbExtensions.Text);
				statusBar1.Panels[ciPanelFileCount].Text = m_SearchEngine.FilesCount.ToString();
				m_frmBatchRep.SetInfo(m_SearchEngine.FilesCount);
				m_SearchEngine.IterateNodes(new AscSearchEngine.FileCallback(ProcessFile));
				//m_frmBatchRep.Close();
				BatchReplaseReport(string.Format("\r\n{0} of {1} file(s) processed.", m_iCurrFileIndex, m_SearchEngine.FilesCount));
			}
			catch(ThreadAbortException) { BatchReplaseReport(string.Format("Job was interruped by user. {0} of {1} file(s) processed.", m_iCurrFileIndex, m_SearchEngine.FilesCount)); }
			catch(Exception ex) 
			{
				BatchReplaseReport(string.Format("\r\nJob was interruped due to error. {0} of {1} file(s) processed.", m_iCurrFileIndex, m_SearchEngine.FilesCount));
				MessageBox.Show("\r\nError while batch processing.\n\nDescription: " + ex.Message, csAppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
				throw ex;
			}	  

		}
		private bool m_bStopBatchReplase = false;

		private void miFileExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	
		public bool StopBatchReplase
		{
			get { return m_bStopBatchReplase; }
			set { m_bStopBatchReplase = value; }
		}

		void SetStatusTetx(string sTest)
		{
			statusBar1.Panels[ciPanelMain].Text = sTest;
		}

		private void toolBarLog_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
//			//TODO: !
//			tbLog.Clear();
//			AscSearchEngine asd = new AscSearchEngine();
//			asd.ScanDir(@"C:\temp\test", "*.h");
//			foreach(string sFile in asd)
//			{
//				BatchReplaseLog(sFile);
//			}
//			return;
			string s = (string)e.Button.Tag;
			switch(s)
			{
				case "ClearLog":    tbLog.Clear(); break;
				case "SaveLog":     LogSave();         break;
				default: MessageBox.Show("Illegal command."); break;
			} 
		}

		void LogSave(string sLogFileName)
		{
			try
			{
				using(StreamWriter sw = new StreamWriter(sLogFileName, false, Encoding.GetEncoding(1251)))
				{
					sw.Write("{0} log file. Created at {1}.\r\n", csAppName, DateTime.Now);
					sw.Write(tbLog.Text);
				}
			}
			catch(Exception e){ MsgBox("Error writing to Log file: " + e.Message); }
		}

		private void toolBar1_ButtonDropDown(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if(e.Button != tbbOpen)
				throw new Exception("   DropDownButton (tbbOpen)!");

			Rectangle r = tbbOpen.Rectangle; //   
			ContextMenu cm = new ContextMenu();
			cm.MergeMenu(miRecent); // ,    miRecent.
			cm.Show(toolBar1, new Point(r.Left, r.Bottom)); //  .
		}

		private void cbIgnoreCase_CheckedChanged(object sender, System.EventArgs e)
		{
			tbReplCount.Visible = !cbReplAll.Checked;
		}

		void EscepeSelection()
		{
			if(tbFind.Focused)
			{
				if(tbFind.SelectedText.Length > 0)
					tbFind.SelectedText = Regex.Escape(tbFind.SelectedText);
			}
		}

		private void menuItem8_Click(object sender, System.EventArgs e)
		{
			EscepeSelection();
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			frmAbout frmAbout1 = new frmAbout();
			frmAbout1.ShowDialog(this);
		}

		private void tbReplCount_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			uint i;
			try
			{
				i = uint.Parse((sender as TextBox).Text);
				if(i <= 0 || i > 1000000)
					throw new Exception();
			} 
			catch(Exception){ e.Cancel = true; MsgBox("The value must be from 1 to 1000000!"); }
		}

		private void AllFlags_CheckStateChanged(object sender, System.EventArgs e)
		{
			SetDirty(true);
		}

		private void cbReplAll_CheckedChanged(object sender, System.EventArgs e)
		{
			tbReplCount.Visible = !cbReplAll.Checked;
		}



		/// <summary>      CheckBox  TextBox.</summary>
		/// <param name="ctrls"> . , this.Controls</param>
		/// <returns>   </returns>
		static Control[] GetStatefullCtrls(System.Windows.Forms.Control.ControlCollection ctrls)
		{
			ArrayList aryCtrls = new ArrayList(ctrls.Count);
			foreach(Control c in ctrls)
			{
				if(c is CheckBox || c is TextBox)
					aryCtrls.Add(c);
				else
					aryCtrls.AddRange(GetStatefullCtrls(c.Controls));
			}
			Control[] cs = new Control[aryCtrls.Count];
			aryCtrls.CopyTo(cs, 0);
			return cs;
		}

		/// <summary>
		///     Log-  
		///  Log    .
		/// </summary>
		void LogSave()
		{
			if(SaveLog.ShowDialog(this) == DialogResult.OK)
				LogSave(SaveLog.FileName);
		}

//		public delegate void MyCallBack(int iPercett);
//		MyCallBack m_MyCallBack;
//		public void SetCallBack(MyCallBack CallBack)
//		{
//			m_MyCallBack = CallBack;
//		}

	}
}

